'This script creates a model using various CorelCAD features

'************************************************************************************************************
'************************************************************************************************************
'************************************************************************************************************
'************************************************************************************************************
REM  1996 Corel Corporation. All rights reserved.
'************************************************************************************************************


WITHOBJECT "CorelCAD.Automation.1"

	.Filenew

	string1$ = "This script creates a model using various CorelCAD features."
	string2$ = "For more information on the features used in this demonstration consult CorelCAD's On-line Help."	
	BEGIN DIALOG DispMessage 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage)
	if Return = 2 then STOP

	string1$ = "The first part of the model is created using the SOLID BOX command, located on the SOLID tool flyout."
	string2$ = ""
	BEGIN DIALOG DispMessage1 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage1)
	if Return = 2 then STOP


	.Box -1, 0, 0, 0, 8, 6, 1
	.ZoomToAll  

	string1$ = "A second SOLID BOX is created by using the SOLID flyout tool. "
	string2$ = "The first solid is used as a reference in the positioning of the second solid."
	BEGIN DIALOG DispMessage2 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage2)
	if Return = 2 then STOP


	.Box -1, 8, 2.5, 1, 0, 3.5, 4
	.SelectPointAt -0.964039, 2.22435, 1, 0
	.ZoomToAll 

	string1$ = "A 3D TRIM will be performed on the second SOLID BOX. It removes the right side corner. "
	string2$ = "The 3D TRIM command is located in the TRANSFORM: SLICE menu."
	BEGIN DIALOG DispMessage3 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage3)
	if Return = 2 then STOP


	.SelectPointAt 6.11711, 6.55759, 1, 0
	.ThreeDTrim 6, 3.5, 4, 6, 2.5, 4, 8, 2.5, 3, 8, 2.5, 4
	.SelectPointAt 7.08237, 4.42053, 4, 0

	string1$ = "A CYLINDER will be created by using the CYLINDER: CENTER and RADIUS Tool."
	string2$ = "The first solid is used as a reference in positioning the CYLINDER."
	BEGIN DIALOG DispMessage4 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage4)
	if Return = 2 then STOP

	.Cylinder -1, 3, 3, 1, 4.5, 3, 1, 4.5, 3, 5

	string1$ = "A second CYLINDER is created. "
	string2$ = "This CYLINDER will be offset -0.5 inches from the top of the first CYLINDER."
	BEGIN DIALOG DispMessage5 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage5)
	if Return = 2 then STOP


	.Cylinder -1, 3, 3, 4.5, 4.6, 3, 4.5, 4.6, 3, 5.5
	.SelectPointAt 4.90813, 5.12774, 4.5, 0

	string1$ = "A FRUSTUM will be created by using the FRUSTUM: CENTER and RADIUS Tool."
	string2$ = "The second CYLINDER is used for positioning the FRUSTUM."
	BEGIN DIALOG DispMessage6 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage6)
	if Return = 2 then STOP


	.Frustum -1, 3, 3, 5.5, 4.6, 3, 5.5, 4.6, 3, 8.5, 3.6, 3, 8.5
	.ZoomToAll 

	string1$ = "All of the objects will be added together using the BOOLEAN ADD command. "
	string2$ = "The BOOLEAN ADD command is located in the TRANSFORM menu."
	BEGIN DIALOG DispMessage7 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG
	
	Return% = DIALOG (DispMessage7)
	if Return = 2 then STOP


	.SelectAll 
	.SolidAdd 

	string1$ = "A third CYLINDER is created."
	string2$ = ""
	BEGIN DIALOG DispMessage8 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage8)
	if Return = 2 then STOP

	.SelectPointAt -3.51962, 4.16571, 5.5, 0
	.Cylinder -1, 3, 3, 8.5, 3.4, 3, 8.5, 3.4, 3, 0.5

	string1$ = "A fourth CYLINDER is created."
	string2$ = "This cylinder will be offset 1 inch from the left corner of the first solid."
	BEGIN DIALOG DispMessage9 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage9)
	if Return = 2 then STOP

	.SelectPointAt -6.22415, 8.07059, 1, 0
	.Cylinder -1, 1, 1, 1, 1.5, 1, 1, 1.5, 1, 0
	.SelectPointAt -6.18213, 7.88377, 1, 0

	string1$ = "A 2 DIRECTIONAL ARRAY is applied to the fourth CYLINDER."
	string2$ = "The 2 DIRECTIONAL ARRAY command is located in the EDIT:ARRAY menu."
	BEGIN DIALOG DispMessage10 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG
	Return% = DIALOG (DispMessage10)
	if Return = 2 then STOP

	.SelectPointAt 1.13535, 1.47567, 1, 0
	.TwoDArray 1, 3, 2, 1, 1, 1, 7, 1, 1, 1, 5, 1
	.SelectPointAt -6.53001, 7.50024, 1, 0

	string1$ = "The CYLINDERS will be subtracted from the first solid using the BOOLEAN SUBTRACT command."
	string2$ = "The BOOLEAN SUBTRACT command is located in the TRANSFORM menu."
	BEGIN DIALOG DispMessage11 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage11)
	if Return = 2 then STOP


	.SetPointXYZ -0.56961, 5.49931, 1
	.SetPointXYZ 1.03385, 1.49885, 1
	.SolidSubtract 
	.SetPointXYZ 0.500013, 5.49271, 1
	.SetPointXYZ 4.34551, 1.36142, 1
	.SolidSubtract 
	.SetPointXYZ 8.02669, 1.98632, 1
	.SetPointXYZ 6.73075, 1.42131, 1
	.SolidSubtract 
	.SetPointXYZ 8.01314, 2.37074, 1
	.SetPointXYZ 6.71044, 5.40762, 1
	.SolidSubtract 
	.SetPointXYZ 5.07216, 6.39047, 1
	.SetPointXYZ 4.35884, 5.26476, 1
	.SolidSubtract 
	.SetPointXYZ -0.902479, 6.54646, 1
	.SetPointXYZ 0.597139, 4.66836, 1
	.SolidSubtract 
	.SetPointXYZ 4.97188, 6.4888, 1
	.SetPointXYZ 0.485054, 10.2066, 1
	.SolidSubtract 

'**************************************************************************************

	string1$ = "A 3 POINT BOX is created."
	string2$ = "The INSERT POINT Roll-up may be used for precise placement of points."
	BEGIN DIALOG DispMessage12 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage12)
	if Return = 2 then STOP

	.Box -1, 3, 1.15, 5.25, 3.25, 1.15, 5.25, 3.25, 2.15, 5.25, 3.25, 2.15, 6.75

	string1$ = "A CIRCULAR ARRAY is applied to the 3 POINT BOX. "
	string2$ = "The CIRCULAR ARRAY is located in the EDIT: ARRAY menu."
	BEGIN DIALOG DispMessage13 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage13)
	if Return = 2 then STOP

	.SelectPointAt -4.86287, 5.29135, 5.25, 0
	.SelectPointAt 2.55075, 2.65973, 5.25, 0
	.CircularArray 6, 360, -1, 3, 3, 8.5, 3, 3, 0.5, 0
	.SelectPointAt -6.34342, 8.52715, 0.5, 0

	string1$ = "The 3 point boxes will be subtracted from the FRUSTUM using the  BOOLEAN SUBTRACT command."
	string2$ = "The BOOLEAN SUBTRACT command is located in the TRANSFORM: BOOLEAN menu."
	BEGIN DIALOG DispMessage14 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage14)
	if Return = 2 then STOP

	.SetPointXYZ -0.833969, 5.93433, 0.5
	.SetPointXYZ 4.60215, 2.075, 5.71564
	.SolidSubtract 
	.SetPointXYZ 6.21069, 0.794059, 5.71564
	.SetPointXYZ 4.45922, 3.84248, 6.75
	.SolidSubtract 
	.SetPointXYZ 6.87806, -0.225065, 6.75
	.SetPointXYZ 3, 4.41575, 6.75
	.SolidSubtract 
	.SetPointXYZ 6.57916, -0.260218, 6.75
	.SetPointXYZ 1.39785, 3.925, 6.43781
	.SolidSubtract 
	.SetPointXYZ 6.57613, 0.0197266, 6.43781
	.SetPointXYZ 1.63581, 1.92371, 6.75
	.SolidSubtract 
	.SetPointXYZ 6.1514, -0.241541, 6.75
	.SetPointXYZ 3, 1.15, 6.6667
	.SolidSubtract 

'*************************************************************************************************************
	string1$ = "A CHAMFER will be applied to the holes in the first solid. "
	string2$ = "The CHAMFER command is located in the TRANSFORM: FILLET menu."
	BEGIN DIALOG DispMessage15 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage15)
	if Return = 2 then STOP
	
	.ChamferEdge 0.1, 0.1, 2.80809, -4.09098, 6.6667
	.ChamferEdge 0.1, 0.1, 6.29395, -4.39703, 6.6667
	.ChamferEdge 0.1, 0.1, 8.36667, -4.5329, 6.6667
	.ChamferEdge 0.1, 0.1, 8.46847, -0.343583, 6.6667
	.ChamferEdge 0.1, 0.1, 6.21138, -0.355124, 6.6667
	.ChamferEdge 0.1, 0.1, 2.54822, -0.898279, 6.6667
	.ChamferEdge 0.1, 0.1, 2.32114, 5.22497, 6.6667

'********************************************************************************************************************
	string1$ = "A PRISM SOLID will be created and subtracted from the second solid."
	string2$ = "The PRISM:CENTER AND VERTEX tool is located on the SOLID tool flyout."
	BEGIN DIALOG DispMessage16 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage16)
	if Return = 2 then STOP

	.PolygonalCylinder -1, 8, 5.40731, 2.5, 2.39976, 6.37127, 2.5, 2.60295, 6.37127, 3.5, 2.60295
	.SelectPointAt -4.6398, 6.3931, 2.60295, 0
	.SetPointXYZ 4.89006, 4.94506, 2.60295
	.SetPointXYZ 6.14576, 2.5, 2.93226
	.SolidSubtract 

'***************************************************************************************************************
	string1$ = "EDGE FILLETS will be applied to the outer edges of the model. "
	string2$ = "The FILLET EDGE command is located in the TRANSFORM:FILLET menu."
	BEGIN DIALOG DispMessage17 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage17)
	if Return = 2 then STOP

	.FilletEdgeRound 0.1, 0, 0.641241, -1.00417, 2.93226, 0
	.FilletEdgeRound 0.1, 0, 0.22017, 1.74735, 2.93226, 0
	.FilletEdgeRound 0.1, 0, 0.775753, -2.2507, 2.93226, 0
	'.FilletEdgeRound 0.1, 0, 0.927999, -1.90984, 2.93226, 0
	.FilletEdgeRound 0.1, 0, 8.73824, -2.25977, 2.93226, 0
	.FilletEdgeRound 0.1, 0, 8.57163, -0.938302, 2.93226, 0
	.FilletEdgeRound 0.1, 0, 8.3136, 1.55329, 2.93226, 0

'***************************************************************************************************************** 

	'Dimension the Model

	string1$ = "A name will be added to the model. " 
	string2$ = ""
	BEGIN DIALOG DispMessage18 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage18)
	if Return = 2 then STOP

	.Text2D "CorelCAD Sample Model", "Times New Roman", 1, 0, 1, 0, 3.1655, 8.424, 2.93226

'*******************************************************************************************************************
	.SelectALL	
	.SetEdgeRefinement 0, 6
	.SetSurfaceRefinement 2, 6

'********************************************************************************************************************
	string1$ = "A MATERIAL will now be applied to the object. "
	string2$ = "RENDERING may take a moment."
	BEGIN DIALOG DispMessage19 25, 70, 316, 56, "CorelCAD: Sample Model Demonstration"
		TEXT  4, 2, 310, 18, String1$
		TEXT  4, 21, 310, 15, String2$
		TEXT  6, 40, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  195, 38, 40, 16, "Next >>>"
		CANCELBUTTON  239, 38, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage19)
	if Return = 2 then STOP

	.zoomtoall
	.selectAll
	.ApplyMaterial "Metallic", "Bronze"
	.ShadeEntireView -1, 0, 3, 0

beep
	BEGIN DIALOG DispMessage20 25, 70, 154, 65,"CorelCAD: Sample Model Demonstration"
		TEXT  29, 14, 98, 8, "The demonstration is complete."
		PUSHBUTTON  61, 34, 40, 16, "End"
	END DIALOG

	Return% = DIALOG (DispMessage20)
	if Return = 2 then STOP

END WITHOBJECT

'********************************************************************************************************************


