'This script will give a demonstration of the solid BOX command

'************************************************************************************************************
'************************************************************************************************************
'************************************************************************************************************
'************************************************************************************************************
REM  1996 Corel Corporation. All rights reserved.
'************************************************************************************************************

REM Declare Subroutines
declare Sub Cross(xcoo&,ycoo&,zcoo&)
declare Sub DoLine(x1&,y1&,z1&,x2&,y2&,z2&)
declare Sub DoBox()


REM Declare Variables
Global Title as string

Rem Set Variable
Title$ = "CorelCAD:SOLID BOX demonstration"

Withobject "CorelCad.Automation.1"
	.FileNew

	string1$ = "This script will demonstrate how to create a SOLID BOX."
	string2$ = "For more information on the BOX tool, consult CorelCAD's On-line Help."
	BEGIN DIALOG DispMessage 25, 70, 316, 75, Title$
		TEXT  4, 4, 310, 12, String1$
		TEXT  4, 18, 310, 16, String2$
		TEXT  4, 46, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  192, 44, 40, 16, "Next >>>"
		CANCELBUTTON  240, 44, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage)
	if Return = 2 then STOP

	string1$ = "A BOX will now be created by using the 3D SOLID: BOX, 2 POINTS tool."
	string2$ = "Two points are required for the construction of the BOX."
	BEGIN DIALOG DispMessage1 25, 70, 316, 75, Title$
		TEXT  4, 4, 310, 12, String1$
		TEXT  4, 18, 310, 16, String2$
		TEXT  4, 46, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  192, 44, 40, 16, "Next >>>"
		CANCELBUTTON  240, 44, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage1)
	if Return = 2 then STOP
	
	string1$ = "The first point will be set to specify the first corner of the BOX."
	string2$ = ""
	BEGIN DIALOG DispMessage2 25, 70, 316, 75, Title$
		TEXT  4, 4, 310, 12, String1$
		TEXT  4, 18, 310, 16, String2$
		TEXT  4, 46, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  192, 44, 40, 16, "Next >>>"
		CANCELBUTTON  240, 44, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage2)
	if Return = 2 then STOP

	CALL Cross(-60,-60,0)

	string1$ = "The second point will be set to specify the diagonal corner of the BOX."
	string2$ = ""
	BEGIN DIALOG DispMessage3 25, 70, 316, 75, Title$
		TEXT  4, 4, 310, 12, String1$
		TEXT  4, 18, 310, 16, String2$
		TEXT  4, 46, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  192, 44, 40, 16, "Next >>>"
		CANCELBUTTON  240, 44, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage3)
	if Return = 2 then STOP

	CAll doline (-60,-60,0,-60,0,0)
	wait for 1
	CAll doline (-60,0,0,0,0,0)
	wait for 1
	CAll doline (0,0,0,0,0,60)
	.zoomToAll
	call cross(0,0,60)
	.zoomToall

	Call doBox 
	.SelectPointAt -69.0982, 3.27301, 50, 0

	.ZoomToAll
	Wait for 2
	.SelectAll
	.deleteselection

	.Box -1, -60,-60,0,0,0,60

	string1$ = "A MATERIAL will now be applied to the BOX"
	string2$ = "RENDERING may take a moment."
	BEGIN DIALOG DispMessage4 25, 70, 316, 75, Title$
		TEXT  4, 4, 310, 12, String1$
		TEXT  4, 18, 310, 16, String2$
		TEXT  4, 46, 170, 8, "Click NEXT to proceed or CANCEL to exit the Script."
		PUSHBUTTON  192, 44, 40, 16, "Next >>>"
		CANCELBUTTON  240, 44, 40, 16
	END DIALOG

	Return% = DIALOG (DispMessage4)
	if Return = 2 then STOP

	.SelectAll
	
	.ApplyMaterial "Mineral", "Bricks"
	.ShadeSelected 0, 0, 3
	String1$ = "By default, the cursor moves about the X-Y PLANE." 
	String2$ = "To set points above or below this plane, hold the CTRL+SHIFT keys down while dragging the mouse. This will move the cursor about the Z-AXIS."
	String3$ = "The INSERT POINT ROLLUP may also be used to set points anywhere in 3D space. This may be activated by pressing the INSERT key."
beep
BEGIN DIALOG EndMess 25, 70, 316, 91, "FINAL HINTS"
	TEXT  4, 4, 310, 16,String1
	TEXT  4, 16, 310, 16, String2
	TEXT  39, 65, 118, 8, "Click END to finish the demonstation."
	PUSHBUTTON  220, 64, 40, 16, "END"
	TEXT  4, 41, 306, 16, string3
END DIALOG

ret = DIALOG(EndMess)

END WITHOBJECT
'************************************************************************************************



SUB Cross (xcoo&,ycoo&,zcoo&)
withobject "corelcad.automation.1"
	.SetPointXYZ xcoo, ycoo, zcoo-7
	.SetPointXYZ xcoo, ycoo, zcoo+7
	.LineSegment 
	.ChangeColor 51, 255, 102
	.SetPointXYZ xcoo-7, ycoo, zcoo
	.SetPointXYZ xcoo+7, ycoo, zcoo
	.LineSegment 
	.ChangeColor 0, 0, 0
	.SetPointXYZ xcoo, ycoo-7, zcoo
	.SetPointXYZ xcoo, ycoo+7, zcoo
	.LineSegment 
	.ChangeColor 255, 0, 0
	.Box -1, xcoo-2, ycoo-2, zcoo-2, xcoo+2, ycoo+2, zcoo+2
	.ChangeColor 0, 204, 255
	.setpointxyz xcoo,ycoo,zcoo
	.linesegment
				wait for 1
	'.selectWithinRegion xcoo-6,ycoo-6,zcoo-6,xcoo+6,ycoo+6,zcoo+6 
end withobject
end sub


SUB DoLine (x1&,y1&,z1&,x2&,y2&,z2&)
	WITHOBJECT "CorelCAD.automation.1"
	.NewLayer " ", , -1, 0, 0, 0, 0, 255, 0, 2, ""
	.setcurrentlayer " "
	.setpointxyz x1,y1,z1 
	.setpointxyz x2,y2,z2
	.arrowLine 3,1
	.setcurrentlayer "Default Layer"
	end withobject
END SUB



SUB DoBox
	WITHOBJECT "CorelCAD.automation.1"
	.NewLayer " ", , -1, 0, 0, 0, 0, 255, 0, 2, ""
	.setcurrentlayer " "
	.Box -1, -60,-60,0,0,0,60
	.setcurrentlayer "Default Layer"

	end withobject
END SUB
